;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program.  If not, see <http://www.gnu.org/licenses/>.

Scriptname LightingBallController extends ObjectReference

ObjectReference Property thisPlayer	Auto Hidden
LightingBall 	Property ball_1 Auto
LightingBall 	Property ball_2 Auto
LightingBall 	Property ball_3 Auto
LightingBall 	Property ball_4 Auto
Bool 		Property debugModeOn = True Auto
Bool 		Property debugModeVerbose Auto
Bool 		Property debugModeXtras = True Auto
Bool        Property specialCaseIsDoorTrigger Auto


EVENT OnInit()

	thisPlayer = Game.getPlayer()

ENDEVENT

EVENT OnCellLoad()

	IF (debugModeOn)			
		Debug.Trace("debugModeOn: " + Self + " is running self-checks...")		
		IF (mask(0, 0, 0, 0))
			String num = "a pair!"
			IF (specialCaseIsDoorTrigger)
				num = "at least one!"
			ENDIF
			Debug.MessageBox("debugModeOn: " + Self + " has no balls, and needs " + num + " Disabling.")		
			disable()
		ELSEIF (mask(1, 0, 0, 0) && (!specialCaseIsDoorTrigger))
			Debug.MessageBox("debugModeOn: " + Self + " has only 1 ball attached, and needs a pair! Disabling.")	
			disable()
		ELSEIF !(mask(1, 1, 0, 0) || mask(1, 1, 1, 0) || mask(1, 1, 1, 1) || (specialCaseIsDoorTrigger && mask(1, 0, 0, 0)))
			Debug.MessageBox("debugModeOn: " + Self + " has mismatched balls, and needs to be fixed! I.E. ball_1 and ball_2 must be set before you can set ball_3.  Disabling.  ")		
			disable()
		ELSEIF (!ball_1.doSelfTest())
			Debug.MessageBox("debugModeOn: " + Self + " needs its 1st ball's " + ball_1 + " lights checked! If don't want lights, then specialCaseNoDisables AND specialCaseNoEnables must be True.")		
			disable()
		ELSEIF ((ball_2 != None) && (!ball_2.doSelfTest()))
			Debug.MessageBox("debugModeOn: " + Self + " needs its 2nd ball's " + ball_2 + " lights checked! Disabling. If don't want lights attached, then set its specialCaseNoDisables AND specialCaseNoEnables to True.")
			disable()
		ELSEIF ((ball_3 != None) && (!ball_3.doSelfTest()))
			Debug.MessageBox("debugModeOn: " + Self + " needs its 3rd ball's " + ball_3 + " lights checked! Disabling. If don't want lights attached, then set its specialCaseNoDisables AND specialCaseNoEnables to True.")
			disable()
		ELSEIF ((ball_4 != None) && (!ball_4.doSelfTest()))
			Debug.MessageBox("debugModeOn: " + Self + " needs its 4th ball's " + ball_4 + " lights checked! Disabling. If don't want lights attached, then set its specialCaseNoDisables AND specialCaseNoEnables to True.")
			disable()		
		ELSEIF (debugModeXtras)		
			IF (ball_1.hasSameLights(ball_2))
				Debug.MessageBox("debugModeXtras: " + Self + " has balls 1 and 2 both control the same lights!  Disabling. ")
				disable()
			ELSEIF (ball_3 != None)
				IF (ball_1.hasSameLights(ball_3))
					Debug.MessageBox("debugModeXtras: " + Self + " has balls 1 and 3 both control the same lights!  Disabling. ")
					disable()
				ELSEIF (ball_2.hasSameLights(ball_3))
					Debug.MessageBox("debugModeXtras: " + Self + " has balls 2 and 3 both control the same lights!  Disabling. ")
					disable()
				ELSEIF (ball_4 != None)
					IF (ball_1.hasSameLights(ball_4))
						Debug.MessageBox("debugModeXtras: " + Self + " has balls 1 and 4 both control the same lights!  Disabling. ")
						disable()
					ELSEIF (ball_2.hasSameLights(ball_4))
						Debug.MessageBox("debugModeXtras: " + Self + " has balls 2 and 4 both control the same lights!  Disabling. ")
						disable()
					ELSEIF (ball_3.hasSameLights(ball_4))
						Debug.MessageBox("debugModeXtras: " + Self + " has balls 3 and 4 both control the same lights!  Disabling. ")
						disable()
					ENDIF
				ENDIF
			ELSEIF ((ball_1 != None) && (ball_1.OnTimerAutoUpdate > 0) && ball_1.OnTimer)
				Debug.MessageBox("debugModeXtras: " + Self + " reports its attached ball_1 is on a timer and auto-updating every " + ball_4.OnTimerAutoUpdate + " seconds.  Auto-updating balls should not be attached to a controller.  Disabling. ")
				disable()
			ELSEIF ((ball_2 != None) && (ball_2.OnTimerAutoUpdate > 0) && ball_2.OnTimer)
				Debug.MessageBox("debugModeXtras: " + Self + " reports its attached ball_2 is on a timer and auto-updating every " + ball_4.OnTimerAutoUpdate + " seconds.  Auto-updating balls should not be attached to a controller.  Disabling. ")
				disable()			
			ELSEIF ((ball_3 != None) && (ball_3.OnTimerAutoUpdate > 0) && ball_3.OnTimer)
				Debug.MessageBox("debugModeXtras: " + Self + " reports its attached ball_3 is on a timer and auto-updating every " + ball_4.OnTimerAutoUpdate + " seconds.  Auto-updating balls should not be attached to a controller.  Disabling. ")
				disable()			
			ELSEIF ((ball_4 != None) && (ball_4.OnTimerAutoUpdate > 0) && ball_4.OnTimer)
				Debug.MessageBox("debugModeXtras: " + Self + " reports its attached ball_4 is on a timer and auto-updating every " + ball_4.OnTimerAutoUpdate + " seconds.  Auto-updating balls should not be attached to a controller.  Disabling. ")
				disable()			
			ENDIF				
		ENDIF
	ENDIF	
	
	IF (specialCaseIsDoorTrigger)
		goToState("DoorTrigger")
	ENDIF

ENDEVENT


EVENT OnCellDetach()

	IF (specialCaseIsDoorTrigger)		
		disableAllLights()
		goToState("DoorTrigger")
	ENDIF

ENDEVENT


EVENT OnTriggerLeave(ObjectReference thisActor)
	
	IF ((thisActor == thisPlayer) && (!specialCaseIsDoorTrigger))
		LightingBall closest = ball_1
		Float 		 lowest  = closest.getDistanceToPlayer()
		Float 		 current = ball_2.getDistanceToPlayer()			
				
		IF (current < lowest)
			closest.disableLights()
			closest = ball_2
			lowest  = current
		ELSE
			ball_2.disableLights()
		ENDIF		
		IF (ball_3 != None)
			current = ball_3.getDistanceToPlayer()			
			IF (current < lowest)
				closest.disableLights()
				closest = ball_3
				lowest  = current
			ELSE
				ball_3.disableLights()
			ENDIF							
			IF (ball_4 != None)
				current = ball_4.getDistanceToPlayer()
				IF (current < lowest)
					closest.disableLights()
					closest = ball_4			
					lowest = current
				ENDIF	
			ENDIF
		ENDIF		
		closest.enableLights()		
		IF (debugModeOn && debugModeVerbose)	
			String name		
			IF     (closest == ball_1) 
				name = "ball_1"
			ELSEIF (closest == ball_2) 
				name = "ball_2"
			ELSEIF (closest == ball_3) 
				name = "ball_3"
			ELSEIF (closest == ball_4) 
				name = "ball_4"
			ENDIF		
			Debug.Notification("debugModeVerbose: " + name + " had closest distance of: " + lowest) 
		ENDIF				
	ENDIF

ENDEVENT


STATE DoorTrigger

	EVENT OnTrigger(ObjectReference thisActor)

		IF (thisActor == thisPlayer)
			enableAllLights()
			goToState("")
		ENDIF
	
	ENDEVENT
	
ENDSTATE


EVENT OnTrigger(ObjectReference thisActor)
ENDEVENT


FUNCTION enableAllLights()
	
	ball_1.enableLights()		
	
	IF (ball_2 != None)
		ball_2.enableLights()
		IF (ball_3 != None)
			ball_3.enableLights()
			IF (ball_4 != None)
				ball_4.enableLights()
			ENDIF
		ENDIF
	ENDIF
	
ENDFUNCTION


FUNCTION disableAllLights()
	
		ball_1.disableLights()		
		
		IF (ball_2 != None)
			ball_2.disableLights()		
			IF (ball_3 != None)
				ball_3.disableLights()
				IF (ball_4 != None)
					ball_4.disableLights()
				ENDIF
			ENDIF		
		ENDIF
		
ENDFUNCTION


Bool FUNCTION mask (Bool b1, Bool b2, Bool b3, Bool b4)

	return ((b1 == (ball_1 != None)) && (b2 == (ball_2 != None)) && (b3 == (ball_3 != None)) && (b4 == (ball_4 != None)))
	
ENDFUNCTION